/**
 * Extrusion. 
 * 
 * Converts a flat image into spatial data points and rotates the points
 * around the center.
 */


import processing.opengl.*;
PFont font;
PImage a,fond;
boolean onetime = true;
int[][] aPixels;
int[][] values;
float angle1,angle2,angle3,n,nmax;
String lettre;

void setup() {
  n=1.1;
  nmax = 50;
  aPixels = new int[width][height];
  values = new int[width][height];
  noFill();
  smooth();
font = loadFont("Arial-BoldMT-48.vlw"); 
textFont(font, 72); 
  // Load the image into a new array
  // Extract the values and store in an array
  a = loadImage("cross.jpg");
  fond = loadImage("fondgod.jpg");
  size(500, 500, OPENGL);
  a.loadPixels();
  for (int i = 0; i < a.height; i++) {
    for (int j = 0; j < a.width; j++) {
      aPixels[j][i] = a.pixels[i*a.width + j];
      values[j][i] = int(brightness(aPixels[j][i]));
    }
  }
  fill(0);
}

void draw() {

  background(255);
  translate(width/2, height/2, 0);
  scale(n);
angle1 += 0.01;
angle2 += 0.01;

rotateX(angle1);
rotateY(angle2);
//rotateZ(angle3);

  if(n > 0.8){ n-=0.01;}
  // Display the image mass
  for (int i = 0; i < a.height; i +=12) {
    for (int j = 0; j < a.width; j +=12) {
      for(int z=0;z<= 100;z+=12){
      //stroke(values[j][i], 153);
      //line(j-a.width/2, i-a.height/2, -values[j][i], j-a.width/2, i-a.height/2, -values[j][i]-10);
      fill(0);
      //int Lrandom = int(random(1,5));
      //switch(Lrandom) {
      //case 1:
      //fill(0,values[j][i]);
      //  lettre = "A";
       // break;
      //case 2:
      //fill(0,values[j][i]);
     //   lettre = "T";
      //  break;
     // case 3:
      //fill(0,values[j][i]);
     //   lettre = "C";
      //  break;
     // case 4:
      //fill(0,values[j][i]);
     //   lettre = "G";
      //  break;
      //}
      color test = a.get(j,i);
      fill(test+random(0,255));
      stroke(test);
      if(values[j][i]<200){//text(lettre,j-a.width/2,i-a.height/2,values[j][i]+z);}
      //line((j-a.width/2)-random(-5,5),(i-a.height/2)-random(-5,5),values[j][i]+z-random(-5,5),j-a.width/2,i-a.height/2,values[j][i]+z);}
      line((j-a.width/2)-10,(i-a.height/2)-10,values[j][i]+z-10,j-a.width/2,i-a.height/2,values[j][i]+z);}
    }
  }
  }
}
void keyPressed(){
  save("cross.png");
}


